/*****************************************************************************/
/* astro.c 								     */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* Global constants used by other modules.				     */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* (c) 2003-2006; Pal, A. (apal@szofi.elte.hu).				     */
/*****************************************************************************/

#include <math.h>

/*****************************************************************************/

#include <astro/astro.h>

/*****************************************************************************/

const	double	au_km = 149597870.0;

const	double	r_earth_equ = 6378.14;
const	double	r_earth_pol = 6356.76;

const	double	r_moon = 1738.0;
const	double	r_sun  = 696000.0;

const	double	m_mercury = 1.66019749e-7,
		m_venus	  = 2.44806226e-6,
		m_earth	  = 3.00374072e-6,
		m_mars	  = 3.22742996e-7,
		m_jupiter = 0.954638698e-3,
		m_saturn  = 0.285838546e-3,
		m_uranus  = 0.436664119e-4,
		m_neptune = 0.515053396e-4;

/*****************************************************************************/
                                 
